"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireDefault(require("react"));

var _jsYaml = _interopRequireDefault(require("js-yaml"));

var _YamlInput = _interopRequireDefault(require("./YamlInput"));

var __jsx = _react["default"].createElement;

var useErrors = function useErrors(onError) {
  var _React$useState = _react["default"].useState(null),
      _React$useState2 = (0, _slicedToArray2["default"])(_React$useState, 2),
      error = _React$useState2[0],
      setError = _React$useState2[1];

  var cleanErrors = function cleanErrors() {
    return setError(null);
  };

  var markError = function markError(_ref) {
    var position = _ref.position,
        message = _ref.message,
        snippet = _ref.snippet;
    setError({
      position: position,
      message: message,
      snippet: snippet
    });
    onError(true);
  };

  return {
    cleanErrors: cleanErrors,
    errorRanges: error,
    markError: markError,
    hasErrors: !!error,
    error: error
  };
};

var YamlEditor = function YamlEditor(_ref2) {
  var value = _ref2.value,
      theme = _ref2.theme,
      _ref2$onError = _ref2.onError,
      onError = _ref2$onError === void 0 ? function () {} : _ref2$onError,
      _ref2$onChange = _ref2.onChange,
      onChange = _ref2$onChange === void 0 ? function () {} : _ref2$onChange;
  // const [error, setError] = React.useState(null);
  var errors = useErrors(onError);

  var _React$useState3 = _react["default"].useState(''),
      _React$useState4 = (0, _slicedToArray2["default"])(_React$useState3, 2),
      currentText = _React$useState4[0],
      setCurrentText = _React$useState4[1];

  var textValue = _jsYaml["default"].dump(value);

  var handleChange = function handleChange(text) {
    try {
      // setCurrentText(text);
      var json = _jsYaml["default"].load(text);

      errors.cleanErrors();
      console.log('🍎 Result', json);
      onChange(json);
      onError(false); // if (error) {
      //   // editor.getAllMarks().forEach((m) => m.clear());
      //   // setError(null);
      // }
    } catch (err) {
      console.error(err.mark.snippet);
      errors.markError({
        position: err.mark.position,
        message: err.message,
        snippet: err.mark.snippet
      }); // setError(err);
      // const errLineNumber = err.mark.line;
      // editor.doc.markText(
      //   { line: errLineNumber, ch: 0 },
      //   { line: errLineNumber },
      //   { className: 'error-line' },
      // );
      // window.editor = editor;
      // window.data = data;
    }
  };

  var handlePrettify = function handlePrettify() {
    setCurrentText('');
  };

  var handleUndo = function handleUndo() {
    setCurrentText('');
    setError(null);
    onError(false);
  };

  return __jsx(_YamlInput["default"], {
    value: currentText || textValue,
    theme: theme,
    onChange: handleChange,
    error: errors.error,
    options: {
      handleTabs: true
    }
  });
};

var _default = YamlEditor;
exports["default"] = _default;